// **********************************************************************
// PUCRS/FACIN
// COMPUTAO GRFICA
//
//
// Programa de testes para manipulao de Imagens
//
//  Este programa deve ser compilador junto com a classe "ImageClass",
//  que est implementada no arquivo "ImageClass.cpp"
//
//  - para compilar no Visual C ou Visual Studio acrescente as seguintes
//        bibliotecas:
//      opengl32.lib glu32.lib glaux.lib glut32.lib
//
//  - para compilar no DEVCPP (ou no g++) acrescente as seguintes
//        bibliotecas:
//        -lopengl32 -lglut32 -lglu32 -lglaux
//
//  - para alterar a imagem que  carregada pelo programa, olhe a
//    rotina 'init' e altere a linha:
//       r = Image->Load("    ");
//
// Marcio Serolli Pinho
// 12/08/2003
//  pinho@inf.pucrs.br
// **********************************************************************



#include <stdio.h>
#include <math.h>

#include <windows.h>

#include "glaux.h"
#include <GL\glut.h>

#include "ImageClass.h"



ImageClass *Image, *NovaImagem;

#define LIMIAR 100
// **********************************************************************
//  void ConvertBlackAndWhite()
//
//
// **********************************************************************
void ConvertBlackAndWhite()
{
    // Tarefa 1:
    //  Mude o valor do LIMIAR para nmeros pequenos como 5 ou 10

    int x,y;
    int i;
    printf ("Iniciou Black & White....");
    //NovaImagem->DrawPixel(20, 1,100,255,0,0 );

    for(x=0;x<Image->SizeX();x++)
    {
        for(y=0;y<Image->SizeY();y++)
        {
            i = Image->GetPointIntensity(x,y);
            // printf("Intens Fora: %5d\n",i);
            if (Image->GetPointIntensity(x,y) < LIMIAR)
            {
                NovaImagem->DrawPixel(x, y,0,0,0);
            }
        }
    }
    printf ("Concluiu Black & White.\n");

}

// **********************************************************************
// void ConvertToGrayScale()
//
//
// **********************************************************************
void ConvertToGrayScale()
{
    // Tarefa 2:
    //  Gerar uma imagem em tons de cinza
    //  Use os mtodos
    //   'ReadPixel' e 'DrawPixel' da classe 'ImageClass'

    //Image->ReadPixel(GLint x, GLint y, unsigned char &r, unsigned char &g, unsigned char &b)
    // Obtm os valores R,G,B de um ponto X,Y da image

    //Image->DrawPixel(GLint x, GLint y, unsigned char r, unsigned char g, unsigned char b)
    // Exibe na coordenada X,Y um ponto com a cor R,G,B na image
}


// **********************************************************************
// void ConvertToHalftone()
//
//
// **********************************************************************
void ConvertToHalftone()
{
    // Tarefa 3:
    //  Gerar uma imagem em duas cores usando o mtodo de Halftone
    // com uma matriz 2x2.
    //
    //  Use o mtodo
    //   'GetPointIntensity' da classe 'ImageClass'
    //
    //  Voce ir precisar ampliar o tamanho da NovaImagem. Para tanto,
    // olhe a rotina 'init' abaixo.

    //  Para alterar o tamanho da janela olhe a funo 'main()'

}
// **********************************************************************
// void DetectImageBorders()
//
//
// **********************************************************************
void DetectImageBorders()
{

    // varredura vertical

    // varredura horizontal

}
#define KERNEL_SIZE 3

// **********************************************************************
// int Count(int x, int y)
//
//
// **********************************************************************
int CountNeighbours(int x, int y, ImageClass *I)
{
    int i,j, count;

    count=0;
    for (i=-KERNEL_SIZE; i<=KERNEL_SIZE;i++)
        for (j=-KERNEL_SIZE; j<=KERNEL_SIZE;j++)
            if (i != j)
            {
                if (I->GetPointIntensity(x+i,y+j) < 200)
                    count++;
            }
    return count;
}

// **********************************************************************
// void MedianaFilter()
//
//
// **********************************************************************
void AplicaMediana()
{
    int x,y;
    int Limite;


    // calcula em 60% o nmero de pixels com cor
    Limite = (int)((KERNEL_SIZE * 2 + 1) * (KERNEL_SIZE * 2 + 1) *.6);

    printf("Iniciou Mediana...\n");

    // Erode the Image
    for(x=KERNEL_SIZE;x<Image->SizeX()-KERNEL_SIZE;x++)
    {
        for(y=KERNEL_SIZE;y<Image->SizeY()-KERNEL_SIZE;y++)
        {
            if (CountNeighbours(x,y, Image) > Limite) //7
            {
                NovaImagem->DrawPixel(x, y,0,0,0);
            }
        }
    }
    printf("Concluiu Mediana...\n");

}

// **********************************************************************
// int Count(int x, int y)
//
//
// **********************************************************************
int MultVizinhos(int x, int y, ImageClass *I)
{
    int i,j, count;

    count=0;
    for (i=-KERNEL_SIZE; i<=KERNEL_SIZE;i++)
        for (j=-KERNEL_SIZE; j<=KERNEL_SIZE;j++)
            if (i != j)
            {
                if (I->GetPointIntensity(x+i,y+j) < 200)
                    count++;
            }
    return count;
}

// **********************************************************************
// void AcentuaBordas()
//
//
// **********************************************************************
void AcentuaBordas()
{
    int x,y;
    int Limite;

    // calcula em 60% o nmero de pixels com cor
    Limite = (int) ((KERNEL_SIZE * 2 + 1) * (KERNEL_SIZE * 2 + 1) *.6);

    printf("Iniciou Mediana...\n");

    // Erode the Image
    for(x=KERNEL_SIZE;x<Image->SizeX()-KERNEL_SIZE;x++)
    {
        for(y=KERNEL_SIZE;y<Image->SizeY()-KERNEL_SIZE;y++)
        {
            if (CountNeighbours(x,y, Image) > Limite) //7
            {
                NovaImagem->DrawPixel(x, y,0,0,0);
            }
        }
    }
    return;
    // Dilate the Image
    for(x=KERNEL_SIZE;x<Image->SizeX()-KERNEL_SIZE;x++)
    {
        for(y=KERNEL_SIZE;y<Image->SizeY()-KERNEL_SIZE;y++)
        {
            if (CountNeighbours(x,y,NovaImagem) > Limite)//3
            {
                NovaImagem->DrawPixel(x, y,0,0,0);
            }
        }
    }

    printf("Concluiu Mediana...\n");

}


// **********************************************************************
//  void init(void)
//  Inicializa os parmetros globais de OpenGL
//
// **********************************************************************
void init(void)
{

    Image = new ImageClass();
    int r;

    glClearColor(0.0f, 0.0f, 1.0f, 1.0f); // Fundo de tela preto

    r = Image->Load("Eagle.BMP");

    if (!r)
        exit(1);
    else
        printf ("Imagem carregada!\n");

    // Instacia o objeto que ir exibor a nova imagem
    // Caso precise alterar o tamanho da nova imagem, mude os parmetros
    // da construtura, na chamada abaixo
    NovaImagem = new ImageClass(Image->SizeX(), Image->SizeY());

    // posiciona a imagem nova ao lado da antiga
    NovaImagem->SetPos(Image->SizeX()+10, 1);

}

// **********************************************************************
//  void reshape( int w, int h )
//  trata o redimensionamento da janela OpenGL
//
// **********************************************************************
void reshape( int w, int h )
{

    // Reset the coordinate system before modifying
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    // Set the viewport to be the entire window
    glViewport(0, 0, w, h);
    gluOrtho2D(0,w,0,h);

    // Set the clipping volume
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();


}
// **********************************************************************
//  void display( void )
//
//
// **********************************************************************
void display( void )
{

    glClear(GL_COLOR_BUFFER_BIT);

    glMatrixMode(GL_MODELVIEW);
    Image->Display();
    NovaImagem->Display();

    glutSwapBuffers();
}


// **********************************************************************
//  void keyboard ( unsigned char key, int x, int y )
//
//
// **********************************************************************
void keyboard ( unsigned char key, int x, int y )
{

    switch ( key )
    {
        case 27: // Termina o programa qdo
        NovaImagem->Delete();
        Image->Delete();
        exit ( 0 );   // a tecla ESC for pressionada
        break;
        case '2':
        ConvertBlackAndWhite();
        glutPostRedisplay();    // obrigatrio para redesenhar a tela
        break;
        case 'm':
        AplicaMediana();
        glutPostRedisplay();    // obrigatrio para redesenhar a tela
        break;
        case ' ':
        //Image->DrawLineH(50, 1, 30, 200,0,0);
        Image->Clear();
        glutPostRedisplay();    // obrigatrio para redesenhar a tela
        break;
        default:
        break;
    }
}

// **********************************************************************
//  void arrow_keys ( int a_keys, int x, int y )
//
//
// **********************************************************************
void arrow_keys ( int a_keys, int x, int y )
{
    switch ( a_keys )
    {
        case GLUT_KEY_UP:       // When Up Arrow Is Pressed...
        break;
        case GLUT_KEY_DOWN:     // When Down Arrow Is Pressed...

        break;
        default:
        break;
    }
}

// **********************************************************************
//  void main ( int argc, char** argv )
//
//
// **********************************************************************
int main ( int argc, char** argv )
{
    glutInit            ( &argc, argv );
    glutInitDisplayMode (GLUT_DOUBLE | GLUT_DEPTH | GLUT_RGB );
    glutInitWindowPosition (10,10);

    // Define o tamanho da janela grfica do programa
    glutInitWindowSize  ( 650, 500);
    glutCreateWindow    ( "Image Loader" );

    init ();

    glutDisplayFunc ( display );
    glutReshapeFunc ( reshape );
    glutKeyboardFunc ( keyboard );
    glutSpecialFunc ( arrow_keys );
    //glutIdleFunc ( display );

    glutMainLoop ( );
    printf("FIM\n");

    return 0;
}


